diff --git a/src/main/java/org/useless/seedviewer/collections/BlockPos3D.java b/src/main/java/org/useless/seedviewer/collections/BlockPos3D.java
new file mode 100644
index 000000000..3fcbff2f7
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/BlockPos3D.java
@@ -0,0 +1,37 @@
+package org.useless.seedviewer.collections;
+
+import java.util.Objects;
+
+/**
+ * Block coordinates of a position relative to the world
+ */
+public final class BlockPos3D extends BlockPos2D {
+    public final int y;
+
+    public BlockPos3D(int x, int y, int z) {
+        super(x, z);
+        this.y = y;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null || getClass() != o.getClass()) return false;
+        BlockPos3D blockPos3D = (BlockPos3D) o;
+        return x == blockPos3D.x && y == blockPos3D.y && z == blockPos3D.z;
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(x, y, z);
+    }
+
+    @Override
+    public String toString() {
+        return "BlockPos3D{" +
+            "x=" + x +
+            ", y=" + y +
+            ", z=" + z +
+            '}';
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/collections/ChunkLocation.java b/src/main/java/org/useless/seedviewer/collections/ChunkLocation.java
new file mode 100644
index 000000000..373ae718c
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/ChunkLocation.java
@@ -0,0 +1,37 @@
+package org.useless.seedviewer.collections;
+
+import java.util.Objects;
+
+/**
+ * Chunk coordinates of a chunk in the world
+ */
+public final class ChunkLocation {
+    public final int x;
+    public final int z;
+
+    public ChunkLocation(int x, int z) {
+        this.x = x;
+        this.z = z;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null || getClass() != o.getClass()) return false;
+        ChunkLocation that = (ChunkLocation) o;
+        return x == that.x && z == that.z;
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(x, z);
+    }
+
+    @Override
+    public String toString() {
+        return "ChunkLocation{" +
+            "x=" + x +
+            ", z=" + z +
+            '}';
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java b/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java
new file mode 100644
index 000000000..13c13f016
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/ChunkPos2D.java
@@ -0,0 +1,48 @@
+package org.useless.seedviewer.collections;
+
+import org.useless.seedviewer.data.Chunk;
+
+import java.util.Objects;
+
+public class ChunkPos2D {
+    public final int x;
+    public final int z;
+
+    public ChunkPos2D(int x, int z) {
+        if (x < 0) {
+            throw new IllegalArgumentException("X must be between in range [0, " + Chunk.CHUNK_SIZE_X + "]!");
+        }
+        if (x > Chunk.CHUNK_SIZE_X) {
+            throw new IllegalArgumentException("X must be between in range [0, " + Chunk.CHUNK_SIZE_X + "]!");
+        }
+        if (z < 0) {
+            throw new IllegalArgumentException("Z must be between in range [0, " + Chunk.CHUNK_SIZE_Z + "]!");
+        }
+        if (z > Chunk.CHUNK_SIZE_Z) {
+            throw new IllegalArgumentException("Z must be between in range [0, " + Chunk.CHUNK_SIZE_Z + "]!");
+        }
+        this.x = x;
+        this.z = z;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null || getClass() != o.getClass()) return false;
+        ChunkPos2D that = (ChunkPos2D) o;
+        return x == that.x && z == that.z;
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(x, z);
+    }
+
+    @Override
+    public String toString() {
+        return "ChunkPos3D{" +
+            "x=" + x +
+            ", z=" + z +
+            '}';
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java b/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java
new file mode 100644
index 000000000..48100c7ab
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/ChunkPos3D.java
@@ -0,0 +1,45 @@
+package org.useless.seedviewer.collections;
+
+import org.useless.seedviewer.data.Chunk;
+
+import java.util.Objects;
+
+/**
+ * Block coordinates of a position relative to a chunk
+ */
+public final class ChunkPos3D extends ChunkPos2D {
+    public final int y;
+
+    public ChunkPos3D(int x, int y, int z) {
+        super(x, z);
+        if (y < 0) {
+            throw new IllegalArgumentException("Y must be between in range [0, " + Chunk.CHUNK_SIZE_Y + "]!");
+        }
+        if (y > Chunk.CHUNK_SIZE_Y) {
+            throw new IllegalArgumentException("Y must be between in range [0, " + Chunk.CHUNK_SIZE_Y + "]!");
+        }
+        this.y = y;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null || getClass() != o.getClass()) return false;
+        ChunkPos3D that = (ChunkPos3D) o;
+        return x == that.x && y == that.y && z == that.z;
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hash(x, y, z);
+    }
+
+    @Override
+    public String toString() {
+        return "ChunkPos3D{" +
+            "x=" + x +
+            ", y=" + y +
+            ", z=" + z +
+            '}';
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/collections/NamespaceID.java b/src/main/java/org/useless/seedviewer/collections/NamespaceID.java
new file mode 100644
index 000000000..e83a58a17
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/NamespaceID.java
@@ -0,0 +1,72 @@
+package org.useless.seedviewer.collections;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Objects;
+
+public final class NamespaceID {
+    private final @NotNull String combined;
+    public final @NotNull String namespace;
+    public final @NotNull String value;
+
+    public NamespaceID(@NotNull String namespace, @NotNull String value) {
+        validateNamespace(namespace);
+        validateValue(value);
+
+        this.combined = namespace + ":" + value;
+        this.namespace = namespace;
+        this.value = value;
+    }
+
+    public NamespaceID(@NotNull String formattedString) {
+        validateFormattedString(formattedString);
+
+        int colonIndex = formattedString.indexOf(":");
+        String _namespace = formattedString.substring(0, colonIndex);
+        String _value = formattedString.substring(colonIndex + 1);
+
+        validateNamespace(_namespace);
+        validateValue(_value);
+
+        this.combined = formattedString;
+        this.namespace = _namespace;
+        this.value = _value;
+    }
+
+    private void validateNamespace(String namespace) {
+        Objects.requireNonNull(namespace, "Namespace cannot be null!");
+        if (namespace.isEmpty()) throw new IllegalArgumentException("Namespace cannot be empty!");
+        if (namespace.contains(":")) throw new IllegalArgumentException("Namespace cannot contain ':'!");
+    }
+
+    private void validateValue(String value) {
+        Objects.requireNonNull(value, "Value cannot be null!");
+        if (value.isEmpty()) throw new IllegalArgumentException("Value cannot be empty!");
+        if (value.contains(":")) throw new IllegalArgumentException("Value cannot contain ':'!");
+    }
+
+    private void validateFormattedString(String formatted) {
+        Objects.requireNonNull(formatted, "String must not be null!");
+        if (!formatted.contains(":")) throw new IllegalArgumentException("String must contain a separator of ':'");
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null) return false;
+        if (o.getClass() == this.getClass()) {
+            return combined.equals(((NamespaceID) o).combined);
+        }
+        return false;
+    }
+
+    @Override
+    public int hashCode() {
+        return combined.hashCode();
+    }
+
+    @Override
+    public String toString() {
+        return combined;
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/collections/ObjectWrapper.java b/src/main/java/org/useless/seedviewer/collections/ObjectWrapper.java
new file mode 100644
index 000000000..6ad6bcbe0
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/collections/ObjectWrapper.java
@@ -0,0 +1,55 @@
+package org.useless.seedviewer.collections;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Objects;
+
+public class ObjectWrapper<T> {
+    protected List<ValueListener<T>> listeners = new ArrayList<>();
+    protected T value;
+    public ObjectWrapper(T initialValue) {
+        this.value = initialValue;
+    }
+
+    public void set(T value) {
+        this.value = value;
+        for (ValueListener<T> listener : listeners) {
+            listener.onValueChanged(value);
+        }
+    }
+
+    public T get() {
+        return value;
+    }
+
+    @Override
+    public boolean equals(Object o) {
+        if (this == o) return true;
+        if (o == null || getClass() != o.getClass()) return false;
+        ObjectWrapper<?> that = (ObjectWrapper<?>) o;
+        return Objects.equals(value, that.value);
+    }
+
+    @Override
+    public int hashCode() {
+        return Objects.hashCode(value);
+    }
+
+    @Override
+    public String toString() {
+        if (value == null) return "null";
+        return value.toString();
+    }
+
+    public ObjectWrapper<T> addChangeListener(@NotNull ValueListener<T> listener) {
+        Objects.requireNonNull(listener);
+        listeners.add(listener);
+        return this;
+    }
+
+    public interface ValueListener<T> {
+        void onValueChanged(T newValue);
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/data/Biome.java b/src/main/java/org/useless/seedviewer/data/Biome.java
new file mode 100644
index 000000000..57b70c018
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/data/Biome.java
@@ -0,0 +1,9 @@
+package org.useless.seedviewer.data;
+
+import org.useless.seedviewer.collections.NamespaceID;
+
+public interface Biome {
+    String getName();
+    NamespaceID getID();
+    int getColor();
+}
diff --git a/src/main/java/org/useless/seedviewer/data/Chunk.java b/src/main/java/org/useless/seedviewer/data/Chunk.java
new file mode 100644
index 000000000..b3d54c63f
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/data/Chunk.java
@@ -0,0 +1,17 @@
+package org.useless.seedviewer.data;
+
+import net.minecraft.core.world.chunk.ChunkSection;
+import org.useless.seedviewer.collections.ChunkPos2D;
+import org.useless.seedviewer.collections.ChunkPos3D;
+
+import java.awt.*;
+
+public interface Chunk {
+    int CHUNK_SIZE_X = net.minecraft.core.world.chunk.Chunk.CHUNK_SIZE_X;
+    int CHUNK_SIZE_Y = net.minecraft.core.world.chunk.Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
+    int CHUNK_SIZE_Z = net.minecraft.core.world.chunk.Chunk.CHUNK_SIZE_Z;
+    Biome getBiome(ChunkPos3D pos);
+    int getBlockColor(ChunkPos3D pos);
+    int getHeight(ChunkPos2D pos);
+    int getWaterDepth(ChunkPos2D pos);
+}
diff --git a/src/main/java/org/useless/seedviewer/data/World.java b/src/main/java/org/useless/seedviewer/data/World.java
new file mode 100644
index 000000000..0bfb5c442
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/data/World.java
@@ -0,0 +1,13 @@
+package org.useless.seedviewer.data;
+
+import org.useless.seedviewer.gui.ChunkProvider;
+
+import java.io.File;
+
+public interface World {
+    File getFolder();
+    long getSeed();
+    String getName();
+    long getLastPlayed();
+    ChunkProvider getChunkProvider();
+}
diff --git a/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java b/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java
new file mode 100644
index 000000000..8493502e4
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java
@@ -0,0 +1,9 @@
+package org.useless.seedviewer.gui;
+
+import org.useless.seedviewer.collections.ChunkLocation;
+import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.data.Chunk;
+
+public interface ChunkProvider {
+    Chunk getChunk(ChunkLocation location);
+}
diff --git a/src/main/java/org/useless/seedviewer/gui/ChunkView.java b/src/main/java/org/useless/seedviewer/gui/ChunkView.java
new file mode 100644
index 000000000..7f330651c
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/gui/ChunkView.java
@@ -0,0 +1,170 @@
+package org.useless.seedviewer.gui;
+
+import com.mojang.logging.LogUtils;
+import org.slf4j.Logger;
+import org.useless.seedviewer.collections.ChunkLocation;
+import org.useless.seedviewer.collections.ChunkPos2D;
+import org.useless.seedviewer.collections.ChunkPos3D;
+import org.useless.seedviewer.data.Biome;
+import org.useless.seedviewer.data.Chunk;
+import org.useless.seedviewer.gui.components.Viewport;
+
+import java.awt.*;
+import java.awt.image.BufferedImage;
+import java.util.concurrent.ExecutorService;
+import java.util.concurrent.Executors;
+import java.util.concurrent.Future;
+
+public class ChunkView {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    private static final ExecutorService InitializerService = Executors.newFixedThreadPool(10);
+    private static final ExecutorService PostProcessorService = Executors.newFixedThreadPool(10);
+
+    private final BufferedImage biomeMapImage = new BufferedImage(Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, BufferedImage.TYPE_INT_ARGB);
+    private final BufferedImage terrainMapImage = new BufferedImage(Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, BufferedImage.TYPE_INT_ARGB);
+    private final BufferedImage heightMapImage = new BufferedImage(Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, BufferedImage.TYPE_INT_ARGB);
+    private final BufferedImage waterDepthMapImage = new BufferedImage(Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z, BufferedImage.TYPE_INT_ARGB);
+
+    private final Rectangle bounds;
+    private final ChunkLocation location;
+    private final ChunkProvider provider;
+    private final Viewport viewport;
+
+    public long lastSeenTime = System.currentTimeMillis();
+
+    private Future<?> loadTask;
+    private Future<?> processTask = null;
+
+    private boolean hasInitialized = false;
+    private volatile boolean hasPostProcessed = false;
+
+    public ChunkView(Viewport viewport, ChunkLocation location, ChunkProvider provider) {
+        this.viewport = viewport;
+        this.location = location;
+        this.provider = provider;
+        this.bounds = new Rectangle(location.x * Chunk.CHUNK_SIZE_X, location.z * Chunk.CHUNK_SIZE_Z, Chunk.CHUNK_SIZE_X, Chunk.CHUNK_SIZE_Z);
+
+        loadTask = InitializerService.submit(
+            () -> {
+                try {
+                    Chunk chunk = provider.getChunk(location);
+
+                    for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
+                        for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
+                            ChunkPos2D pos2D = new ChunkPos2D(x, z);
+                            int h = chunk.getHeight(pos2D) - 1;
+                            if (h < 0) h = 0;
+                            heightMapImage.setRGB(x, z, h & 0xFF);
+
+                            int wd = chunk.getWaterDepth(pos2D) & 0xFF;
+                            waterDepthMapImage.setRGB(x, z, 0xFF_00_00_00 | wd << 16 | wd << 8 | wd);
+
+                            Biome b = chunk.getBiome(new ChunkPos3D(x, h, z));
+                            biomeMapImage.setRGB(x, z, b.getColor() | 0x80_00_00_00);
+
+                            terrainMapImage.setRGB(x, z, chunk.getBlockColor(new ChunkPos3D(x, h, z)));
+                        }
+                    }
+                } catch (Exception e) {
+                    LOGGER.error("Error when initializing chunk {}, {}", location.x, location.z, e);
+                }
+                finally {
+                    hasInitialized = true;
+                }
+            }
+        );
+    }
+
+    public boolean hasInit() {
+        return hasInitialized;
+    }
+
+    public boolean hasProcessed() {
+        return hasPostProcessed;
+    }
+
+    public void process(ChunkView posZ) {
+        if (hasProcessed()) return;
+        synchronized (this) {
+            processTask = PostProcessorService.submit(() -> {
+                try {
+                    for (int x = 0; x < Chunk.CHUNK_SIZE_X; x++) {
+                        for (int z = 0; z < Chunk.CHUNK_SIZE_Z; z++) {
+                            int depth = waterDepthMapImage.getRGB(x, z) & 0xFF;
+
+                            int shade = 220;
+                            if (depth == 0) {
+                                int lastHeight;
+                                if (z == 0) {
+                                    lastHeight = posZ.getHeightMapImage().getRGB(x, z + 15) & 0xFF;
+                                } else {
+                                    lastHeight = heightMapImage.getRGB(x, z - 1) & 0xFF;
+                                }
+                                int height = heightMapImage.getRGB(x, z) & 0xFF;
+
+                                if (height == lastHeight) {
+                                    shade = 220;
+                                } else if (height < lastHeight) {
+                                    shade = 180;
+                                } else {
+                                    shade = 255;
+                                }
+                            } else {
+                                double d3 = (double) depth * 0.1D + (double) ((x + z) & 0b1) * 0.2D;
+                                if(d3 < 0.5D) {
+                                    shade = 255;
+                                } else if (d3 > 0.9D) {
+                                    shade = 180;
+                                } else {
+                                    shade = 220;
+                                }
+                            }
+
+
+                            if (shade != 255) {
+                                final int current = terrainMapImage.getRGB(x, z) ;
+                                final int a = (((current >> 24) & 0xFF));
+                                final int r = (((current >> 16) & 0xFF) * shade) / 0xFF;
+                                final int g = (((current >>  8) & 0xFF) * shade) / 0xFF;
+                                final int b = (((current      ) & 0xFF) * shade) / 0xFF;
+                                terrainMapImage.setRGB(x, z, (a << 24 | r << 16 | g << 8 | b));
+                            }
+                        }
+                    }
+                } finally {
+                    hasPostProcessed = true;
+                    viewport.repaint();
+                }
+            });
+        }
+    }
+
+    public ChunkLocation getLocation() {
+        return location;
+    }
+
+    public BufferedImage getBiomeMapImage() {
+        return biomeMapImage;
+    }
+
+    public BufferedImage getTerrainMapImage() {
+        return terrainMapImage;
+    }
+
+    public BufferedImage getHeightMapImage() {
+        return heightMapImage;
+    }
+
+    public Rectangle getWorldBounds() {
+        return bounds;
+    }
+
+    public void kill() {
+        if (processTask != null) {
+            processTask.cancel(true);
+        }
+        if (loadTask != null) {
+            loadTask.cancel(true);
+        }
+    }
+}
diff --git a/src/main/java/org/useless/seedviewer/gui/SeedViewer.java b/src/main/java/org/useless/seedviewer/gui/SeedViewer.java
new file mode 100644
index 000000000..9ebbd4b00
--- /dev/null
+++ b/src/main/java/org/useless/seedviewer/gui/SeedViewer.java
@@ -0,0 +1,184 @@
+package org.useless.seedviewer.gui;
+
+import com.mojang.logging.LogUtils;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+import org.useless.seedviewer.SeedViewerMain;
+import org.useless.seedviewer.collections.ChunkLocation;
+import org.useless.seedviewer.gui.components.InfoPanel;
+import org.useless.seedviewer.gui.components.InputPanel;
+import org.useless.seedviewer.gui.components.Viewport;
+
+import javax.swing.*;
+import java.awt.*;
+import java.awt.event.ComponentAdapter;
+import java.awt.event.ComponentEvent;
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Properties;
+import java.util.Random;
+
+public class SeedViewer extends JFrame {
+    private static final Logger LOGGER = LogUtils.getLogger();
+    // Static Configuration
+    public static final int TICKS_PER_SECOND = 10;
+    public static final int BEZEL = 15;
+
+    // Storage
+    public final Properties launchProperties;
+    private volatile boolean needsResize = true;
+
+    // Configuration
+
+    // Components
+    public final Viewport viewport;
+    public final InputPanel inputPanel;
+    public final InfoPanel infoPanel;
+
+    public SeedViewer(Properties properties) {
+        LOGGER.info("Starting Seed Viewer!");
+        this.launchProperties = properties;
+
+        viewport = new Viewport(this);
+        inputPanel = new InputPanel(this);
+        infoPanel = new InfoPanel(this);
+
+
+        initFrame();
+        addComponents();
+
+        Thread mainThread = new Thread(
+            () -> {
+                long tickCount = 0;
+                while (true) {
+                    try {
+                        tick();
+                        tickCount++;
+                    } catch (Exception e){
+                        LOGGER.error("Exception when running tick!", e);
+                    }
+
+                    if (tickCount % (5 * TICKS_PER_SECOND) == 0) {
+                        System.gc();
+                    }
+
+                    try {
+                        Thread.sleep(1000/TICKS_PER_SECOND);
+                    } catch (InterruptedException e) {
+                        LOGGER.error("Unexpected interrupt in tick thread!", e);
+                    }
+                }
+            }
+        );
+        mainThread.setName("Main");
+        mainThread.setPriority(6);
+        mainThread.start();
+    }
+
+    public void initFrame() {
+        // Creating instance of JFrame
+        LOGGER.info("Initializing Frame");
+        this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
+        this.setTitle("BTA Seed Viewer! Version: " + SeedViewerMain.VERSION);
+        this.setSize(960, 720);
+        this.setMinimumSize(new Dimension(480, 360));
+        this.setResizable(true);
+        this.addComponentListener(new ComponentAdapter() {
+            @Override
+            public void componentResized(ComponentEvent e) {
+                needsResize = true;
+                viewport.repaint();
+            }
+        });
+        this.setLayout(null); // using no layout managers
+        this.setVisible(true); // making the frame visible
+
+        LOGGER.info("Loading Icons");
+        try {
+            List<Image> l = new ArrayList<>();
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/1024.png")));
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/512.png")));
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/256.png")));
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/128.png")));
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/64.png")));
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/32.png")));
+            l.add(Toolkit.getDefaultToolkit().getImage(getClass().getResource("/assets/seedviewer/textures/icons/16.png")));
+            this.setIconImages(l);
+        } catch (Exception e) {
+            LOGGER.error("Failed to load icons!", e);
+        }
+    }
+
+    public void addComponents() {
+        // State labels
+        LOGGER.info("Creating Labels");
+        infoPanel.setup();
+        this.add(infoPanel);
+
+        // Checkboxes
+        LOGGER.info("Creating Check boxes");
+        inputPanel.setup();
+        this.add(inputPanel);
+
+        LOGGER.info("Creating Image frame");
+        viewport.setup();
+        this.add(viewport);
+    }
+
+    public void initComponents() {
+        if (!needsResize) return;
+        LOGGER.info("Initializing Components");
+        needsResize = false;
+        int screenWidth = this.getContentPane().getWidth();
+        int screenHeight = this.getContentPane().getHeight();
+
+        {
+            int inWidth = screenWidth / 4;
+            if (inWidth < 100) inWidth = 100;
+            if (inWidth > 200) inWidth = 200;
+            int inHeight = screenHeight - BEZEL * 2;
+            inputPanel.onResize(new Rectangle(0, BEZEL, inWidth, inHeight/2));
+            inputPanel.setVisible(true);
+        }
+
+        {
+            int inWidth = screenWidth / 4;
+            if (inWidth < 100) inWidth = 100;
+            if (inWidth > 200) inWidth = 200;
+            int inHeight = screenHeight - BEZEL * 2;
+            infoPanel.onResize(new Rectangle(0, inputPanel.getY() + inputPanel.getHeight() - 1, inWidth, inHeight/2));
+            infoPanel.setVisible(true);
+        }
+
+        {
+            int viewWidth = screenWidth - (BEZEL * 2) - (inputPanel.isVisible() ? inputPanel.getWidth() : 0);
+            int viewX = BEZEL + (inputPanel.isVisible() ? inputPanel.getWidth() : 0);
+            viewport.onResize(
+                new Rectangle(
+                    viewX,
+                    BEZEL,
+                    viewWidth,
+                    screenHeight - BEZEL * 2));
+        }
+    }
+
+    public void queueResize() {
+        needsResize = true;
+    }
+
+    public void forceResize() {
+        queueResize();
+        initComponents();
+    }
+
+    public synchronized void tick() {
+        initComponents();
+        viewport.tick();
+    }
+
+    public static boolean isSlimeChunk(long worldSeed, @NotNull ChunkLocation location) {
+        long slimeXOR = 0x3AD8025FL;
+        Random slimerandom = new Random(worldSeed + (location.x * location.x * 0x4c1906L) + (location.x * 0x5ac0dbL) + (location.z * location.z * 0x4307a7L) + (location.z * 0x5f24fL) ^ slimeXOR);
+        return slimerandom.nextInt(10) == 0;
+    }
+}
